"use strict";

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.promise");

require("core-js/modules/es.regexp.exec");

require("core-js/modules/es.string.replace");

require("core-js/modules/es.string.split");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withJSONBakedInitialProps = void 0;

require("regenerator-runtime/runtime");

var _withBakedInitialProps = require("./withBakedInitialProps");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var defaultBakedInitialPropsIdentifier = function defaultBakedInitialPropsIdentifier(ctx) {
  var path = ctx.asPath.split('?')[0];

  if (path === '/') {
    return 'index';
  }

  return path.replace(/^\/|\/$/g, '').replace('/', '-').toLowerCase();
};
/**
 * @description
 * The JSON HOC which writes your baked data to a JSON file and automaticly fetches the baked data.
 * @function withBakedInitialProps
 *
 * @param {React.Component} PageComponent
 * @param {Object} options
 * @param {bakeWhen} options.bakeWhen
 * @param {getInitialPropsWhen} options.getInitialPropsWhen
 * @returns {React.Component}
 */


var withJSONBakedInitialProps = function withJSONBakedInitialProps(PageComponent, options) {
  var getBakedInitialPropsIdentifier = PageComponent.getBakedInitialPropsIdentifier || defaultBakedInitialPropsIdentifier;

  PageComponent.bakeInitialProps =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(initialPropsData, ctx) {
      var id, fs;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return getBakedInitialPropsIdentifier(ctx);

            case 2:
              id = _context.sent;
              fs = require('fs');
              _context.prev = 4;
              _context.next = 7;
              return fs.promises.mkdir('out/static/data/', {
                recursive: true
              });

            case 7:
              _context.next = 11;
              break;

            case 9:
              _context.prev = 9;
              _context.t0 = _context["catch"](4);

            case 11:
              _context.next = 13;
              return fs.promises.writeFile("out/static/data/".concat(id, ".json"), JSON.stringify(initialPropsData));

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[4, 9]]);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();

  PageComponent.getBakedInitialProps =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(ctx) {
      var id, response, data;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return getBakedInitialPropsIdentifier(ctx);

            case 2:
              id = _context2.sent;
              _context2.next = 5;
              return fetch("/static/data/".concat(id, ".json"));

            case 5:
              response = _context2.sent;
              _context2.next = 8;
              return response.json();

            case 8:
              data = _context2.sent;
              return _context2.abrupt("return", data);

            case 10:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x3) {
      return _ref2.apply(this, arguments);
    };
  }();

  return (0, _withBakedInitialProps.withBakedInitialProps)(PageComponent, options);
};

exports.withJSONBakedInitialProps = withJSONBakedInitialProps;